unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: Jani Nikula <jani@nikula.org>
To: notmuch@notmuchmail.org
Subject: [PATCH] completion: update bash completion
Date: Wed,  6 Nov 2013 21:25:37 +0200	[thread overview]
Message-ID: <1383765937-20921-1-git-send-email-jani@nikula.org> (raw)

Update bash completion to cover new commands and options:

notmuch compact --quiet --backup=DIR
notmuch count --output=files --batch --input=FILE
notmuch insert --folder=DIR --create-folder
notmuch search --exclude=all --duplicate=N
notmuch show --include-html
notmuch tag --batch --input=FILE --remove-all

---

This logically depends on id:cover.1383481295.git.jani@nikula.org
which adds --quiet and --backup=DIR parameters to compact.
---
 completion/notmuch-completion.bash | 89 +++++++++++++++++++++++++++++++++++---
 1 file changed, 82 insertions(+), 7 deletions(-)

diff --git a/completion/notmuch-completion.bash b/completion/notmuch-completion.bash
index 7bd7745..04324bb 100644
--- a/completion/notmuch-completion.bash
+++ b/completion/notmuch-completion.bash
@@ -59,6 +59,29 @@ _notmuch_search_terms()
     __ltrim_colon_completions "${cur}"
 }
 
+_notmuch_compact()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--backup)
+	    _filedir
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--backup= --quiet"
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+    esac
+}
+
 _notmuch_config()
 {
     local cur prev words cword split
@@ -89,19 +112,23 @@ _notmuch_count()
     $split &&
     case "${prev}" in
 	--output)
-	    COMPREPLY=( $( compgen -W "messages threads" -- "${cur}" ) )
+	    COMPREPLY=( $( compgen -W "messages threads files" -- "${cur}" ) )
 	    return
 	    ;;
 	--exclude)
 	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
 	    return
 	    ;;
+	--input)
+	    _filedir
+	    return
+	    ;;
     esac
 
     ! $split &&
     case "${cur}" in
 	-*)
-	    local options="--output= --exclude="
+	    local options="--output= --exclude= --batch --input="
 	    compopt -o nospace
 	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
 	    ;;
@@ -141,6 +168,39 @@ _notmuch_dump()
     esac
 }
 
+_notmuch_insert()
+{
+    local cur prev words cword split
+    # handle tags with colons and equal signs
+    _init_completion -s -n := || return
+
+    $split &&
+    case "${prev}" in
+	--folder)
+	    _filedir
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	--*)
+	    local options="--create-folder --folder="
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    return
+	    ;;
+	+*)
+	    COMPREPLY=( $(compgen -P "+" -W "`notmuch search --output=tags \*`" -- ${cur##+}) )
+	    ;;
+	-*)
+	    COMPREPLY=( $(compgen -P "-" -W "`notmuch search --output=tags \*`" -- ${cur##-}) )
+	    ;;
+    esac
+    # handle tags with colons
+    __ltrim_colon_completions "${cur}"
+}
+
 _notmuch_new()
 {
     local cur prev words cword split
@@ -231,7 +291,7 @@ _notmuch_search()
 	    return
 	    ;;
 	--exclude)
-	    COMPREPLY=( $( compgen -W "true false flag" -- "${cur}" ) )
+	    COMPREPLY=( $( compgen -W "true false flag all" -- "${cur}" ) )
 	    return
 	    ;;
     esac
@@ -239,7 +299,7 @@ _notmuch_search()
     ! $split &&
     case "${cur}" in
 	-*)
-	    local options="--format= --output= --sort= --offset= --limit= --exclude="
+	    local options="--format= --output= --sort= --offset= --limit= --exclude= --duplicate="
 	    compopt -o nospace
 	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
 	    ;;
@@ -273,7 +333,7 @@ _notmuch_show()
     ! $split &&
     case "${cur}" in
 	-*)
-	    local options="--entire-thread= --format= --exclude= --body= --format-version= --part= --verify --decrypt"
+	    local options="--entire-thread= --format= --exclude= --body= --format-version= --part= --verify --decrypt --include-html"
 	    compopt -o nospace
 	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
 	    ;;
@@ -287,9 +347,24 @@ _notmuch_tag()
 {
     local cur prev words cword split
     # handle tags with colons and equal signs
-    _init_completion -n := || return
+    _init_completion -s -n := || return
+
+    $split &&
+    case "${prev}" in
+	--input)
+	    _filedir
+	    return
+	    ;;
+    esac
 
+    ! $split &&
     case "${cur}" in
+	--*)
+	    local options="--batch --input= --remove-all"
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    return
+	    ;;
 	+*)
 	    COMPREPLY=( $(compgen -P "+" -W "`notmuch search --output=tags \*`" -- ${cur##+}) )
 	    ;;
@@ -307,7 +382,7 @@ _notmuch_tag()
 
 _notmuch()
 {
-    local _notmuch_commands="config count dump help new reply restore search setup show tag"
+    local _notmuch_commands="compact config count dump help insert new reply restore search setup show tag"
     local arg cur prev words cword split
     _init_completion || return
 
-- 
1.8.4.rc3

             reply	other threads:[~2013-11-06 19:25 UTC|newest]

Thread overview: 4+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2013-11-06 19:25 Jani Nikula [this message]
2013-11-07 13:30 ` [PATCH] completion: update bash completion Tomi Ollila
2013-11-09 13:26 ` David Bremner
2013-11-11  3:18 ` David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1383765937-20921-1-git-send-email-jani@nikula.org \
    --to=jani@nikula.org \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).